## openstructure 2.11.1

=== CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Author: Marco Biasini
#-------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.22 FATAL_ERROR)

# Set CMake policies
# Behaviour of target_link_libraries, always link by full path. CMP0060 can
# disable this to stay compatible with old projects. We want the new behaviour
# since before we needed to provide the full path ourselves, that is: we
# manually forced CMake to the new scheme.
cmake_policy(SET CMP0060 NEW)

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.31.0")
  # See CMP0177 for more information
  # To summarize: all paths given to the install command are normalized starting
  # from cmake version 3.31. Starting from 3.31 you'll start to see warnings if
  # you use the OLD behaviour but some paths would need normalization.
  # The problem with ost: some of the paths that we give install look like:
  # xyz/./bla. So its actually a good thing to run them through normalization
  # which would give xyz/bla
  cmake_policy(SET CMP0177 NEW)
endif()

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.30.0")
  # See CMP0167 for more information
  # to summarize: Starting from boost 1.70, boost comes with a package
  # configuration file BoostConfig.cmake. Starting from cmake 3.30,
  # this is the way to go and users get warned if the old FindBoost module
  # gets used.
  cmake_policy(SET CMP0167 NEW)
endif()

project(OpenStructure CXX C)
set (CMAKE_EXPORT_COMPILE_COMMANDS 1)
set (OST_VERSION_MAJOR 2)
set (OST_VERSION_MINOR 11)
set (OST_VERSION_PATCH 1)
set (OST_VERSION_STRING ${OST_VERSION_MAJOR}.${OST_VERSION_MINOR}.${OST_VERSION_PATCH} )
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake_support)
include(OST)

option(USE_SHADER "whether to compile with shader support"
       OFF)
option(USE_RPATH "embed rpath upon make install"
       OFF)
option(COMPILE_TMTOOLS "whether to compile the tmalign and tmscore programs"
       OFF)
option(PROFILE "whether to compile with profiling support"
       OFF)       
option(ENABLE_GUI "whether the graphical user interface should be enabled"
       ON)
option(ENABLE_GFX "whether graphics support should be enabled"
       ON)
option(OPENGLPREFERENCE_LEGACY "whether to use the OpenGL Legacy GL implementation"
       OFF)
option(ENABLE_INFO "whether openstructure should be compiled with support for the info library"
       ON)
option(USE_DOUBLE_PRECISION "whether to compile in double precision" 
       OFF)
option(ENABLE_SPNAV "whether 3DConnexion devices should be supported"
      OFF)
option(STATIC_PROPERTY_WORKAROUND "workaround for static property bug with some boost/boost_python combinations" OFF)
option(COMPILE_TESTS "whether unit tests should be compiled by default" OFF)
option(ENABLE_STATIC "whether static libraries should be compiled" OFF)
option(UBUNTU_LAYOUT "whether Debian/Ubuntu's lib and libexec directory layout should be used" OFF)
option(HIDDEN_VISIBILITY "on gcc, use -fvisibility=hidden" OFF)
option(ENABLE_MM "whether openmm support is added" OFF)
option(ENABLE_PARASAIL, "whether parasail alignment library should be included" OFF)

if (CXX)
  set(CMAKE_CXX_COMPILER ${CXX})
endif()

if (CC)
  set(CMAKE_C_COMPILER ${CC})
endif()

if (FORTRAN_COMPILER)
  set(CMAKE_FORTRAN_COMPILER ${FORTRAN_COMPILER})
endif()



if (PREFIX)
  set(CMAKE_INSTALL_PREFIX ${PREFIX})
endif()

if (SYS_ROOT)
  set(CMAKE_PREFIX_PATH ${SYS_ROOT})
endif()

if (OPTIMIZE)
  set(CMAKE_BUILD_TYPE Release)
  set(_OPT ON)
else()
   set(CMAKE_BUILD_TYPE Debug)
    set(_OPT OFF)
endif()

if (USE_DOUBLE_PRECISION)
  set(_DOUBLE_PREC ON)
else()
  set(_DOUBLE_PREC OFF)
  set(_DOUBLE_PREC OFF)
endif()

if (NOT ENABLE_INFO)
  set(ENABLE_GFX OFF)
endif()

if (NOT ENABLE_GFX)
  set(ENABLE_GUI OFF)
endif()

if (ENABLE_INFO)
  set(_INFO ON)
else()
  set(_INFO OFF)
endif()

if (ENABLE_GUI)
  set(_UI ON)
else()
  set(_UI OFF)
endif()

if (ENABLE_GFX)
  set(_OPENGL ON)
else()
  set(_OPENGL OFF)
endif()

if (USE_SHADER)
  set(_SHADER ON)
else()
  set(_SHADER OFF)
endif()
if (COMPILE_TMTOOLS)
  set(_TM_TOOLS ON)
else()
  set(_TM_TOOLS OFF)
endif()
if (PROFILE)
  set(_PROFILE ON)
else()
  set(_PROFILE OFF)
endif()
if(ENABLE_MM)
  set(_OPENMM ON)
else()
  set(_OPENMM OFF)
endif()
if(ENABLE_PARASAIL)
  set(_PARASAIL ON)
else()
  set(_PARASAIL OFF)
endif()


if (UBUNTU_LAYOUT)
  set(_UBUNTU_LAYOUT ON)
else()
  set(_UBUNTU_LAYOUT OFF)
endif()

if (COMPOUND_LIB)
  set(_COMP_LIB "${COMPOUND_LIB}")
  if (NOT IS_ABSOLUTE "${COMPOUND_LIB}")
    set(COMPOUND_LIB "${CMAKE_CURRENT_BINARY_DIR}/${COMPOUND_LIB}")
  endif()
else()
  set(_COMP_LIB "NONE")
endif()

if (STATIC_PROPERTY_WORKAROUND)
  set(_STATICPROPS ON)
else()
  set(_STATICPROPS OFF)
endif()

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

setup_stage()
file(MAKE_DIRECTORY ${STAGE_DIR}
     ${EXECUTABLE_OUTPUT_PATH}
     ${HEADER_STAGE_PATH}
     ${LIB_STAGE_PATH}
     ${LIBEXEC_STAGE_PATH})

setup_compiler_flags()

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY)

if (ENABLE_STATIC AND UNIX AND NOT APPLE)
  set (CMAKE_FIND_LIBRARY_SUFFIXES .a)
endif()

# Python needed before Boost
find_package(Python 3.6 REQUIRED COMPONENTS Interpreter Development)
# where Python modules live
set(PYTHON_MODULE_PATH "python${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}/site-packages/")

set(_BOOST_MIN_VERSION 1.70)

if(BOOST_VERSION)
  message(STATUS "forcing boost to version ${BOOST_VERSION}")
  set(_BOOST_MIN_VERSION ${BOOST_VERSION})
endif()
find_package(Boost ${_BOOST_MIN_VERSION} 
             COMPONENTS unit_test_framework
                        filesystem
                        system
                        iostreams
                        program_options
                        regex
                        thread
                        python
             REQUIRED)
if (WIN32)
   ADD_DEFINITIONS("-DBOOST_ALL_NO_LIB")
endif()

if (ENABLE_INFO)        
  find_package(Qt5Xml REQUIRED)
  set(QT_LIBRARIES ${QT_LIBRARIES} Qt5::Xml)
endif()

if (OPTIMIZE)
  if (CXX_FLAGS)
    set (CMAKE_CXX_FLAGS_RELEASE ${CXX_FLAGS})
  endif()
  if (C_FLAGS)
    set (CMAKE_C_FLAGS_RELEASE ${C_FLAGS})
  endif()
else()
  if (CXX_FLAGS)
    set(CMAKE_CXX_FLAGS_DEBUG ${CXX_FLAGS})
  endif()
  if (C_FLAGS)
    set(CMAKE_C_FLAGS_DEBUG ${C_FLAGS})
  endif()
endif()
if (ENABLE_GFX)
  if (OPENGLPREFERENCE_LEGACY)
    set(OpenGL_GL_PREFERENCE LEGACY)
  else()
    set(OpenGL_GL_PREFERENCE GLVND)
  endif(OPENGLPREFERENCE_LEGACY)
  find_package(OpenGL REQUIRED)
endif()

find_package(EIGEN 3.2.0 REQUIRED)
find_package(SQLITE3 3.7.13 REQUIRED)
find_package(PNG REQUIRED)
find_package(FFTW REQUIRED)
find_package(TIFF REQUIRED)

if(ENABLE_MM)
  find_package(OpenMM REQUIRED)
  set(_OPENMM_PLUGINS "${OPEN_MM_PLUGIN_DIR}")
else(ENABLE_MM)
  set(_OPENMM_PLUGINS "NONE")
endif(ENABLE_MM)

if(ENABLE_PARASAIL)
  find_package(Parasail REQUIRED)
endif(ENABLE_PARASAIL)

if (ENABLE_STATIC)
  set(Boost_LIBRARIES)
  set(Boost_USE_STATIC_LIBS ON)
  find_package(Boost ${_BOOST_MIN_VERSION} 
               COMPONENTS filesystem system iostreams regex thread REQUIRED)
  find_package(ZLIB REQUIRED)
   
  if (UNIX AND NOT APPLE)
    set(STATIC_LIBRARIES ${Boost_LIBRARIES} ${FFTW_LIBRARIES} ${TIFF_LIBRARIES} 
        ${PNG_LIBRARY} ${ZLIB_LIBRARY})
  else ()
    set(STATIC_LIBRARIES ${Boost_LIBRARIES} ${FFTW_LIBRARIES} ${TIFF_LIBRARIES} 
        ${PNG_LIBRARY} ${ZLIB_LIBRARY})
  endif()
endif()

if (ENABLE_GUI)
  find_package(Qt5Widgets REQUIRED)
  find_package(Qt5OpenGL REQUIRED)
  set(QT_LIBRARIES ${QT_LIBRARIES} Qt5::Gui Qt5::Widgets Qt5::Core)
  ost_find_python_module(PyQt5)
  ost_find_python_module_alt("PyQt5.sip;sip")
endif()

if (ENABLE_SPNAV)
  #find_package(SpNav REQUIRED)
  set(_SPNAV ON)
else()
  set(_SPNAV OFF)
endif()

if (CMAKE_COMPILER_IS_GNUCXX)
  # do not write back into cache, otherwise the compile command line gets expanded
  # with multiple -fno-strict-aliasing flags, triggering a complete rebuild whenever
  # cmake is run
  set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fno-strict-aliasing")
  if("${CMAKE_CXX_COMPILER_VERSION}" VERSION_GREATER "4.6")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-attributes")
  endif("${CMAKE_CXX_COMPILER_VERSION}" VERSION_GREATER "4.6")
  if(HIDDEN_VISIBILITY) 
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
    set (_HIDDEN_VIS ON)
  else(HIDDEN_VISIBILITY)
    set (_HIDDEN_VIS OFF)
  endif(HIDDEN_VISIBILITY)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unknown-warning-option")
endif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
if(CMAKE_C_COMPILER_ID MATCHES "Clang")
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unknown-warning-option")
endif(CMAKE_C_COMPILER_ID MATCHES "Clang")

# basic environment
include_directories(${Boost_INCLUDE_DIRS} 
                    ${FFTW_INCLUDE_DIRS} 
                    ${EIGEN3_INCLUDE_DIRS}
                    ${TIFF_INCLUDE_DIR}
                    ${PNG_INCLUDE_DIRS}
                    ${OPEN_MM_INCLUDE_DIRS}
                    ${SQLITE3_INCLUDE_DIRS}
                    ${PARASAIL_INCLUDE_DIR})

if (UNIX)
  SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  if(USE_RPATH)
    set(_USE_RPATH ON)
    SET(CMAKE_INSTALL_RPATH "$ORIGIN/../${LIB_DIR}")
    SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  else()
    set(_USE_RPATH OFF)
   SET(CMAKE_INSTALL_RPATH "")
   SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
  endif() 
endif()

if (ENABLE_STATIC)
  SET(CMAKE_SKIP_BUILD_RPATH TRUE)
  SET(LINK_SEARCH_END_STATIC TRUE) 
endif()

add_subdirectory(modules)
add_subdirectory(scripts)
add_subdirectory(tools)
add_subdirectory(actions)
add_subdirectory(doxygen)
# deployment has to come last, to ensure that all install commands are run before deployment
# magic is done
add_subdirectory(deployment)

set(FILES_TO_BE_REMOVED ${PROJECT_BINARY_DIR}/stage tests)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
                             "${FILES_TO_BE_REMOVED}")


#ost_match_boost_python_version(${Python_LIBRARIES})

if (CMAKE_COMPILER_IS_GNUCXX)
   set(HIDDEN_VIS_MSG 
       "\n   Hidden object visibility  (-DHIDDEN_VISIBILITY) : ${_HIDDEN_VIS}")
endif()
message(STATUS 
        "OpenStructure will be built with the following options:\n"
        "   Install Prefix                        (-DPREFIX) : ${CMAKE_INSTALL_PREFIX}\n"
        "   RPath in install                   (-DUSE_RPATH) : ${_USE_RPATH}\n"
        "   Info support                     (-DENABLE_INFO) : ${_INFO}\n"
        "   Graphical interface               (-DENABLE_GUI) : ${_UI}\n"
        "   OpenGL support                    (-DENABLE_GFX) : ${_OPENGL}\n"
        "   Shader support                    (-DUSE_SHADER) : ${_SHADER}\n"
        "   SpaceNav Device support         (-DENABLE_SPNAV) : ${_SPNAV}\n"
        "   OpenMM support                     (-DENABLE_MM) : ${_OPENMM}\n"
        "   OpenMM plugins            (-DOPEN_MM_PLUGIN_DIR) : ${_OPENMM_PLUGINS}\n"
        "   Parasail alignment library   (-DENABLE_PARASAIL) : ${_PARASAIL}\n"
        "   Optimize                            (-DOPTIMIZE) : ${_OPT}\n"
        "   Profiling support                    (-DPROFILE) : ${_PROFILE}\n"
        "   Double Precision        (-DUSE_DOUBLE_PRECISION) : ${_DOUBLE_PREC}\n"
        "   Compound Lib                    (-DCOMPOUND_LIB) : ${_COMP_LIB}\n"
        "   TMAlign and TMScore          (-DCOMPILE_TMTOOLS) : ${_TM_TOOLS}\n"
        "   Static Libraries               (-DENABLE_STATIC) : ${ENABLE_STATIC}\n"
        "   Debian/Ubuntu directory layout (-DUBUNTU_LAYOUT) : ${_UBUNTU_LAYOUT}"
        ${HIDDEN_VIS_MSG})


# LocalWords:  CMake CMP

=== actions/CMakeLists.txt ===
add_custom_target(actions ALL)

ost_action_init()
ost_action(ost-compare-ligand-structures actions)
ost_action(ost-compare-structures actions)
ost_action(ost-compare-structures-legacy actions)

=== deployment/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#  Author:  Andreas Schenk
#
#  This file contains the CPack configuration common to all platforms.
#
#-------------------------------------------------------------------------------

#only include deployment configureation for the main project and not for subprojects
if(${PROJECT_SOURCE_DIR} STREQUAL ${CMAKE_SOURCE_DIR})

  INCLUDE(InstallRequiredSystemLibraries)
  
  set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "OpenStructure Framework")
  set(CPACK_PACKAGE_VENDOR "2008-2020 -- The OpenStructure Team")
  set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
  set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE.txt")
  set(CPACK_PACKAGE_VERSION_MAJOR ${OST_VERSION_MAJOR})
  set(CPACK_PACKAGE_VERSION_MINOR ${OST_VERSION_MINOR})
  set(CPACK_PACKAGE_VERSION_PATCH ${OST_VERSION_PATCH})
  
  # using include instead of add_subdirectory avoid creating a child scope
  if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    include(macos/CMakeLists.txt) 
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    include(linux/CMakeLists.txt) 
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    include(win/CMakeLists.txt) 
  endif()

  INCLUDE(CPack) 

endif(${PROJECT_SOURCE_DIR} STREQUAL ${CMAKE_SOURCE_DIR})

=== doxygen/CMakeLists.txt ===
set(BUILD_DIR ${CMAKE_BINARY_DIR})
set(SOURCE_DIR ${CMAKE_SOURCE_DIR})
configure_file("Doxyfile.in" "Doxyfile")

=== modules/CMakeLists.txt ===
# recursively process all subdirectories
file(GLOB ALL_FILES *)
foreach(full_name ${ALL_FILES})
  get_filename_component(fname ${full_name} NAME)
  if(NOT ${fname} MATCHES ".*\\.svn" 
     AND NOT ${fname} MATCHES ".*CMakeFiles" 
     AND NOT ${fname} MATCHES ".*main"
     AND NOT ${fname} MATCHES "doc")
      if(IS_DIRECTORY ${full_name})
        add_subdirectory(${fname})
      endif()
  endif()
endforeach()

=== scripts/CMakeLists.txt ===
set(SUBST_DICT BUILD_TYPE=${CMAKE_BUILD_TYPE} Python_EXECUTABLE=${Python_EXECUTABLE}
Python_VERSION=${Python_VERSION} LIBDIR=${LIB_DIR} LIBEXEC_PATH=${LIBEXEC_PATH}
PYTHON_MODULE_PATH=${PYTHON_MODULE_PATH})
message("${BUILD_TYPE}")
add_custom_target(ost_scripts ALL)

# may god forgive us
if (ENABLE_GUI)
  add_dependencies(ost_scripts _ost_gui)
elseif(ENABLE_GFX)
  add_dependencies(ost_scripts _ost_gfx)
else()
  add_dependencies(ost_scripts _ost_io)
endif()

if (NOT ENABLE_STATIC)
  if(WIN32)
    script(NAME  dng.bat INPUT dng.bat.in SUBSTITUTE ${SUBST_DICT}
           TARGET ost_scripts)
    script(NAME ost.bat INPUT ost.bat.in SUBSTITUTE ${SUBST_DICT}
           TARGET ost_scripts)
  else()
    script(NAME ost_config INPUT ost_config.in SUBSTITUTE ${SUBST_DICT}
           TARGET ost_scripts OUTPUT_DIR ${LIBEXEC_PATH})
    script(NAME ost INPUT ost.in SUBSTITUTE ${SUBST_DICT} 
           TARGET ost_scripts)
    if (ENABLE_GUI)
      script(NAME dng INPUT dng.in SUBSTITUTE ${SUBST_DICT}
             TARGET ost_scripts)
    endif()
  endif()

  script(NAME ost_startup.py INPUT ost_startup.py.in SUBSTITUTE ${SUBST_DICT} 
         TARGET ost_scripts OUTPUT_DIR "${LIB_DIR}/${PYTHON_MODULE_PATH}/ost" )    

  set(INIT_SCRIPTS 
  )
  set(SPD "${LIB_DIR}/${PYTHON_MODULE_PATH}/ost")
  if (ENABLE_GUI)
    list(APPEND INIT_SCRIPTS dng_startup.py)
  endif()
  copy_if_different("${CMAKE_CURRENT_SOURCE_DIR}" "${STAGE_DIR}/${SPD}" 
                  "${INIT_SCRIPTS}" "python init scripts" ost_scripts)

  install(FILES ${INIT_SCRIPTS} DESTINATION "${SPD}")

endif()

=== tools/CMakeLists.txt ===
add_subdirectory(molck)

=== deployment/linux/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#  Author:  Andreas Schenk
#
#  This file contains the Linux specific CPack configuration.
#
#-------------------------------------------------------------------------------

if(NOT CPACK_GENERATOR)
  include(CheckLSBTypes)
  if(( ${LSB_DISTRIBUTOR_ID} MATCHES "centos" AND ${LSB_RELEASE} GREATER 5.9)
   OR (${LSB_DISTRIBUTOR_ID} MATCHES "redhat" AND ${LSB_RELEASE} GREATER 5.9)
   OR (${LSB_DISTRIBUTOR_ID} MATCHES "fedora"))
    set(CPACK_GENERATOR "RPM")
  elseif(${LSB_DISTRIBUTOR_ID} MATCHES "debian")
    set(CPACK_GENERATOR "DEB")
  else()
    set(CPACK_GENERATOR "TGZ")
  endif()
endif(NOT CPACK_GENERATOR)

if(CPACK_GENERATOR MATCHES "DEB")
  set(CPACK_DEBIAN_PACKAGE_MAINTAINER "The OpenStructure developers")
elseif(CPACK_GENERATOR MATCHES "RPM")
elseif(CPACK_GENERATOR MATCHES "TGZ")
  install(CODE "
    if(NOT ${CMAKE_INSTALL_PREFIX} MATCHES \${CMAKE_INSTALL_PREFIX})
      set(LIB_DIR ${LIB_DIR})#pass libdir variable in install code block
      set(LIBEXEC_PATH ${LIBEXEC_PATH})#pass libexec_path variable in install code block
      set(_UBUNTU_LAYOUT ${_UBUNTU_LAYOUT})#pass ubuntu_layout variable in install code block
      set(ARCH ${ARCH})#pass arch variable in install code block
      if(NOT ${_USE_RPATH} STREQUAL ON)
        message(\"======================================================================\")
        message(\"|          Warning, no rpaths will be embedded upon install.         |\")
        message(\"|        Dependency resolution during packaging will not work.       |\")
        message(\"| Add -DUSE-RPATH=1 when running cmake to switch on rpath embedding. |\")
        message(\"======================================================================\")
      endif(NOT ${_USE_RPATH} STREQUAL ON)
      set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/ost/cmake_support)
      include(CopyDependencies)
      set(OST_BINARIES \"\${CMAKE_INSTALL_PREFIX}/bin/lddt\"
                       \"\${CMAKE_INSTALL_PREFIX}/bin/chemdict_tool\"
                       \"\${CMAKE_INSTALL_PREFIX}/bin/molck\"
                       \"\${CMAKE_INSTALL_PREFIX}/${LIBEXEC_PATH}/gosty\")

      copy_python(${Python_INCLUDE_DIRS} ${Python_VERSION} new_python_binary)
      list(APPEND OST_BINARIES \${new_python_binary})

      file(GLOB_RECURSE OST_PYMODS \"\${CMAKE_INSTALL_PREFIX}/${LIB_DIR}/*.so\")
      list(APPEND  OST_BINARIES \${OST_PYMODS})

      #copy Qt stuff
      copy_qt(${QT_LIBRARY_DIR} ${QT_PLUGINS_DIR} qt_plugins)
      list(APPEND  OST_BINARIES \${qt_plugins})

      copy_dependencies(\"\${OST_BINARIES}\")

      #copy examples into bundle
      file (COPY ${CMAKE_SOURCE_DIR}/examples DESTINATION \"\${CMAKE_INSTALL_PREFIX}/share/openstructure/\") 
    endif(NOT ${CMAKE_INSTALL_PREFIX} MATCHES \${CMAKE_INSTALL_PREFIX})
  ")
elseif(CPACK_GENERATOR MATCHES "TGZ_NODEP")
  set(CPACK_GENERATOR "TGZ")
else(CPACK_GENERATOR MATCHES "DEB")
  message(FATAL_ERROR "Uknown CPack generator")
endif(CPACK_GENERATOR MATCHES "DEB")

=== deployment/win/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#  Author:  Andreas Schenk
#
#  This file contains the Windows specific CPack configuration.
#
#-------------------------------------------------------------------------------

install(CODE "
  if(NOT ${CMAKE_INSTALL_PREFIX} STREQUAL \${CMAKE_INSTALL_PREFIX})
    message(FATAL_ERROR "The Windows installer cannot yet be created with CPack.")            
  endif(NOT ${CMAKE_INSTALL_PREFIX} STREQUAL \${CMAKE_INSTALL_PREFIX})
")

=== modules/bindings/CMakeLists.txt ===
add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(pymod)

=== modules/config/CMakeLists.txt ===
set(SUBST_DICT OST_VERSION_MAJOR=${OST_VERSION_MAJOR} OST_VERSION_MINOR=${OST_VERSION_MINOR} 
    OST_VERSION_PATCH=${OST_VERSION_PATCH})

set(OST_CONFIG_HEADERS
base.hh
config.hh
dllexport.hh
version.hh
)

set(animations_enabled 0)

if (USE_SHADER)
  set(shader_support 1)
else()
  set(shader_support 0)
endif()
if (PROFILE)
  set(profiling_enabled 1)
else()
  set(profiling_enabled 0)
endif()
if (_DOUBLE_PREC)
  set(double_prec 1)
else()
  set(double_prec 0)
endif()
if (_DOUBLE_PREC)
  set(double_prec 1)
else()
  set(double_prec 0)
endif()
if (_STATICPROPS)
  set(static_props 1)
else()
  set(static_props 0)
endif()
if (FFTW_USE_THREADS)
  set(fftw_use_threads 1)
else()
  set(fftw_use_threads 0)
endif()
if (_UBUNTU_LAYOUT)
  set(ubuntu_layout 1)
else()
  set(ubuntu_layout 0)
endif()
if (ENABLE_INFO)
  set(info_enabled 1)
else()
  set(info_enabled 0)
endif()
if (ENABLE_PARASAIL)
  set(parasail_enabled 1)
else()
  set(parasail_enabled 0)
endif()

set(config_hh_generator "CMake")
set(CONFIG_HH_FILE "${CMAKE_CURRENT_SOURCE_DIR}/config.hh")
set(VERSION_HH_FILE "${CMAKE_CURRENT_SOURCE_DIR}/version.hh")
configure_file(config.hh.in ${CONFIG_HH_FILE})
configure_file(version.hh.in ${VERSION_HH_FILE})
add_custom_target(ost_config)
stage_and_install_headers("${OST_CONFIG_HEADERS}" "ost" "ost_config")

=== modules/db/CMakeLists.txt ===
add_subdirectory(src)
add_subdirectory(pymod)
add_subdirectory(tests)

=== debian/changelog ===
openstructure (2.11.1-1) unstable; urgency=medium

  * Upload to unstable (Closes: #1110617)

 -- Andrius Merkys <merkys@debian.org>  Wed, 15 Oct 2025 03:32:58 -0400

openstructure (2.11.1-1~exp) experimental; urgency=medium

  * New upstream version 2.11.1

 -- Andrius Merkys <merkys@debian.org>  Fri, 10 Oct 2025 04:46:15 -0400

=== debian/control ===
Source: openstructure
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 clustalw [amd64 arm64 mips64el ppc64el riscv64 s390x] <!nocheck>,
 cmake,
 debhelper-compat (= 13),
 dh-python,
 dssp <!nocheck>,
 libboost-all-dev,
 libeigen3-dev,
 libfftw3-dev,
 libglu1-mesa-dev,
 libopenmm-dev [amd64 arm64 armhf ppc64el riscv64 alpha ia64 loong64 m68k sh4],
 libopenmm-plugins [amd64 arm64 armhf ppc64el riscv64 alpha ia64 loong64 m68k sh4],
 libparasail-dev [amd64],
 libpng-dev,
 libqt5opengl5-dev,
 libsqlite3-dev,
 libtiff-dev,
 python3-dev,
 python3-matplotlib <!nocheck>,
 python3-numpy <!nocheck>,
 python3-pil <!nocheck>,
 python3-pyqt5,
 python3-scipy <!nocheck>,
 qtbase5-dev,
 voronota <!nocheck>,
Standards-Version: 4.6.2
Homepage: https://www.openstructure.org
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debichem-team/openstructure.git
Vcs-Browser: https://salsa.debian.org/debichem-team/openstructure

Package: libost-base2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libost-base2.2,
Multi-Arch: same
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-bindings2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-conop2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-db2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-geom2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gfx2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gui2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img-alg2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-info2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-io2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-mol-alg2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-mol-mm2.11
Architecture: amd64 arm64 armhf ppc64el riscv64 alpha ia64 loong64 m68k sh4
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-mol2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-seq-alg2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-seq2.11
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: openstructure
Architecture: any
Depends:
 python3-ost,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 libcifpp-data,
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: python3-ost
Architecture: any
Section: python
Depends:
 python3-matplotlib,
 python3-numpy,
 python3-pil,
 python3-pyqt5,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
X-Python3-Version: ${python3:Versions}
Description: Open-Source Computational Structural Biology Framework - Python 3 package
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-base-dev
Section: libdevel
Architecture: any
Depends:
 libost-base2.11 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-bindings-dev
Section: libdevel
Architecture: any
Depends:
 libost-bindings2.11 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-conop-dev
Section: libdevel
Architecture: any
Depends:
 libost-conop2.11 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-db-dev
Section: libdevel
Architecture: any
Depends:
 libost-db2.11 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-geom-dev
Section: libdevel
Architecture: any
Depends:
 libost-geom2.11 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gfx-dev
Section: libdevel
Architecture: any
Depends:
 libost-gfx2.11 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gui-dev
Section: libdevel
Architecture: any
Depends:
 libost-gui2.11 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img-alg-dev
Section: libdevel
Architecture: any
Depends:
 libost-img-alg2.11 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img-dev
Section: libdevel
Architecture: any
Depends:
 libost-img2.11 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-info-dev
Section: libdevel
Architecture: any
Depends:

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

OPEN_MM_PLUGIN_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/openmm/plugins
CONFIGURE_OPTIONS = -DOPTIMIZE=ON -DUBUNTU_LAYOUT=ON

ifeq ($(shell test -e $(OPEN_MM_PLUGIN_DIR) && echo YES),YES)
	CONFIGURE_OPTIONS += -DENABLE_MM=ON -DOPEN_MM_PLUGIN_DIR=$(OPEN_MM_PLUGIN_DIR)
endif

ifeq (amd64,$(DEB_HOST_ARCH))
    CONFIGURE_OPTIONS += -DENABLE_PARASAIL=ON
endif

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_OPTIONS)

execute_after_dh_auto_install:
	find debian/tmp/usr/lib -name '*.pyc' | xargs --no-run-if-empty rm

execute_after_dh_install:
	find debian/python3-ost/usr/lib/python3/dist-packages -type f \
		| xargs --no-run-if-empty chmod -x
	find debian/tmp/usr/lib -name 'libost_*.so.*' \
		| while read LIB; \
			do dh_install -p$$(echo $$LIB | cut -d / -f 5 | cut -d . -f 1 | sed 's/_/-/g')2.11 \
				$$LIB usr/lib/$(DEB_HOST_MULTIARCH); \
			done
	find debian/tmp/usr/lib -name 'libost_*.so' \
		| while read LIB; \
			do dh_install -p$$(echo $$LIB | cut -d / -f 5 | cut -d . -f 1 | sed 's/_/-/g')-dev \
				$$LIB usr/lib/$(DEB_HOST_MULTIARCH); \
			done
	chmod u+w debian/openstructure/usr/bin/*

=== debian/tests/control ===
Tests: python
Depends:
 clustalw [amd64 arm64 mips64el ppc64el riscv64 s390x],
 dssp,
 ncbi-blast+,
 voronota,
 @,
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="searchmode=plain,uversionmangle=s/-/~/g" \
https://git.scicore.unibas.ch/schwede/openstructure/-/tags \
 /schwede/openstructure/-/archive/[^/]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
